%module IFU_py_io
%{
#include <IFU_io.h>
#define PY_ARRAY_UNIQUE_SYMBOL PyArray_IFU_io_API
// #include <Numeric/arrayobject.h>
#include <numarray/arrayobject.h>
%}
%init %{
   import_array();
%}

/* SWIG LIBRARY */
%include <typemaps.i> 

/* IFU io macros */
%include "typemacros.i" 

/* IFU iolib */
%include <items.h>
%include <3D_items.h>
%include <funcdecl.h>
%include <iofuncdecl.h>
%include <3D_iofunc.h>

/* data types */

#define CHAR	99  /* 'c' */
#define SHORT	115 /* 's' */
#define USHORT	117 /* 'u' */
#define INT  	105 /* 'i' */
#define LONG	108 /* 'l' */
#define FLOAT   102 /* 'f' */
#define DOUBLE  100 /* 'd' */
#define STRING	83  /* 'S' */

/* included in py_misc.h */

double RD_spec(SPECTRUM *, int );
double RD_frame(IMAGE2D *, int , int );
double RD_cube(IMAGE3D *, int , int , int );
double RD_slice(SLICE *slice, int);
int RD_qslice(SLICE *, int );

void WR_spec(SPECTRUM *, int, double);
void WR_frame(IMAGE2D *, int, int, double);
void WR_cube(IMAGE3D *, int, int, int,double);

float coord_spec(SPECTRUM *, int);
int pixel_spec(SPECTRUM *, int);

int in_spectrum(SPECTRUM *, float);
int in_frame(IMAGE2D *, float, float );
int in_cube(IMAGE3D *, float, float , float);

/*
int WR_dslice(SLICE *, int , double);
*/
int WR_qslice(SLICE *, int , int );

