/* --------------------------------------------

 	Typemaps MACROS

Version 1.0 AP 04/08/2004
 --------------------------------------------*/


/* so that WR_desc may accept direct values */

%typemap(in) void *in_descval(short sval, int ival, float fval, double dval, char *cp) {

        switch(arg3) {

            case CHAR :
            if(!PyArg_Parse(obj4,"s",&cp)) goto fail;
            $1 = (void *)cp;
            break;

            case SHORT :
            if(!PyArg_Parse(obj4,"i",&ival)) goto fail;
            sval = (short)ival;
            $1 = (void *)&sval;
            break;

            case INT :
            case LONG :
            if(!PyArg_Parse(obj4,"i",&ival)) goto fail;
            $1 = (void *)&ival;
            break;

            case FLOAT :
            if(!PyArg_Parse(obj4,"f",&fval)) goto fail;
            $1 = (void *)&fval;
            break;

            case DOUBLE :
            if(!PyArg_Parse(obj4,"d",&dval)) goto fail;
            $1 = (void *)&dval;
            break;
        }
}

/* so that RD_desc may accept tcl object to return values */

%typemap(in,numinputs=0) void *out_descval(void *temp) {
	$1 = NULL;       
}

%typemap(check) void *out_descval {
	
	switch(arg3) {

            case CHAR :
            $1 = (void *)malloc((arg4+1)*sizeof(char));
            break;
            case SHORT :
            $1 = (void *)malloc(arg4*sizeof(short));
            break;
            case INT :
            case LONG :
            $1 = (void *)malloc(arg4*sizeof(long));
            break;
            case FLOAT :
            $1 = (void *)malloc(arg4*sizeof(float));
            break;
            case DOUBLE :
            $1 = (void *)malloc(arg4*sizeof(double));
            break;
        }
}

%typemap(argout) void *out_descval {
	
	char *cp;
	double dval, *dp;
	int ival, *ip;
	float *fp;
	short *sp;

	if ((arg3 != CHAR) && (arg4 == 1)) { /* returns single value */

	  switch(arg3) {

            case CHAR :
            cp = (char *)$1;
            $result = PyString_FromString(cp);
            break;

            case SHORT :
	    sp = (short *)$1;
            ival = *sp;
            $result = PyInt_FromLong((long)ival);
            break;

            case INT :
            case LONG :
	    ip = (int *)$1;
            $result = PyInt_FromLong((long)*ip);
            break;

            case FLOAT :
	    fp = (float *)$1;
	    dval = *fp;
            $result = PyFloat_FromDouble(dval);
            break;

            case DOUBLE :
	    dp = (double *)$1;
            $result = PyFloat_FromDouble(*dp);
            break;
         }
       }
       else {					/* returns a list */
            int i;

            $result = PyList_New(arg4);
            for (i=0; i< arg4; i++) {

                switch(arg3) {

                    case SHORT :
                    sp = (short *)$1;
                    ival = *(sp+i);
                    PyList_SetItem($result,i,PyInt_FromLong((long)ival));
                    break;

                    case INT :
                    case LONG :
                    ip = (int *)$1;
                    dval = *(ip+i);
                    PyList_SetItem($result,i,PyInt_FromLong((long)ival));
                    break;

                    case FLOAT :
                    fp = (float *)$1;
                    dval = *(fp+i);
                    PyList_SetItem($result,i,PyFloat_FromDouble(dval));
                    break;

                    case DOUBLE :
                    dp = (double *)$1;
                    dval = *(dp+i);
                    PyList_SetItem($result,i,PyFloat_FromDouble(dval));
                    break;
                }
            }
        }
	free($1);
}

/* so that WR_tbl may accept direct values */

%typemap(in) void *in_tblval(short sval, int ival, float fval, double dval, char *cp) {

	int type;
	char format[20], unit[lg_unit+1];

	get_col_info(arg1,arg3, &type, format, unit);

        switch(type) {

            case CHAR :
            if(!PyArg_Parse($input,"s",&cp)) goto fail;
            $1 = (void *)cp;
            break;

            case SHORT :
            if(!PyArg_Parse($input,"i",&ival)) goto fail;
            sval = (short)ival;
            $1 = (void *)&sval;
            break;

            case INT :
            case LONG :
            if(!PyArg_Parse($input,"i",&ival)) goto fail;
            $1 = (void *)&ival;
            break;

            case FLOAT :
            if(!PyArg_Parse($input,"f",&fval)) goto fail;
            $1 = (void *)&fval;
            break;

            case DOUBLE :
            if(!PyArg_Parse($input,"d",&dval)) goto fail;
            $1 = (void *)&dval;
            break;
        }
}

/* so that RD_tbl may accept tcl object to return a value */

%typemap(in,numinputs=0) void *out_tblval(void *temp) {
	$1 = NULL;       
}

%typemap(check) void *out_tblval(int type) {
	
	int len;
	char format[20], unit[lg_unit+1];

	get_col_info(arg1,arg3, &type, format, unit);

	switch(type) {

            case CHAR :
	    sscanf(format,"A%d",&len);
            $1 = (void *)malloc((len+1)*sizeof(char));
            break;
            case SHORT :
            $1 = (void *)malloc(1*sizeof(short));
            break;
            case INT :
            case LONG :
            $1 = (void *)malloc(1*sizeof(long));
            break;
            case FLOAT :
            $1 = (void *)malloc(1*sizeof(float));
            break;
            case DOUBLE :
            $1 = (void *)malloc(1*sizeof(double));
            break;
        }
}

%typemap(argout) void *out_tblval {
	
	char *cp;
	double dval, *dp;
	int ival, *ip;
	float *fp;
	short *sp;

	switch(type4) {

            case CHAR :
            cp = (char *)$1;
            $result = PyString_FromString(cp);
            break;

            case SHORT :
	    sp = (short *)$1;
            ival = *sp;
            $result = PyInt_FromLong((long)ival);
            break;

            case INT :
            case LONG :
	    ip = (int *)$1;
            $result = PyInt_FromLong((long)*ip);
            break;

            case FLOAT :
	    fp = (float *)$1;
	    dval = *fp;
            $result = PyFloat_FromDouble((double)dval);
            break;

            case DOUBLE :
	    dp = (double *)$1;
            $result = PyFloat_FromDouble((double)*fp);
            break;
        }
	free($1);
}

/* RD_col */

%typemap(in,numinputs=0) void *out_tblcol(void *temp) {
	$1 = NULL;       
}

%typemap(check) void *out_tblcol(int type) {
	
	int len;
	char format[20], unit[lg_unit+1];

	get_col_info(arg1,arg2, &type, format, unit);

	switch(type) {

            case CHAR :
	    sscanf(format,"A%d",&len);
            $1 = (void *)malloc(arg1->row*(len+1)*sizeof(char));
            break;
            case SHORT :
            $1 = (void *)malloc(arg1->row*sizeof(short));
            break;
            case INT :
            case LONG :
            $1 = (void *)malloc(arg1->row*sizeof(long));
            break;
            case FLOAT :
            $1 = (void *)malloc(arg1->row*sizeof(float));
            break;
            case DOUBLE :
            $1 = (void *)malloc(arg1->row*sizeof(double));
            break;
        }
}

%typemap(argout) void *out_tblcol {
	
	char *cp;
	double dval, *dp;
	int ival, *ip;
	float *fp;
	short *sp;
        int i;

        $result = PyList_New(arg1->row);
        for (i=0; i<arg1->row; i++) {

                switch(type3) {

                    case SHORT :
                    sp = (short *)$1;
                    ival = *(sp+i);
                    PyList_SetItem($result,i,PyInt_FromLong((long)ival));
                    break;

                    case INT :
                    case LONG :
                    ip = (int *)$1;
                    dval = *(ip+i);
                    PyList_SetItem($result,i,PyInt_FromLong((long)ival));
                    break;

                    case FLOAT :
                    fp = (float *)$1;
                    dval = *(fp+i);
                    PyList_SetItem($result,i,PyFloat_FromDouble(dval));
                    break;

                    case DOUBLE :
                    dp = (double *)$1;
                    dval = *(dp+i);
                    PyList_SetItem($result,i,PyFloat_FromDouble(dval));
                    break;
                }
        }
	free($1);
}

/* get and set data as arrays */

static PyObject *init_spec_array(SPECTRUM *);
static PyObject *init_frame_array(IMAGE2D *);
static PyObject *init_cube_array(IMAGE3D *);

%{
static PyObject *init_spec_array(SPECTRUM *spec) {

	PyArrayObject *result;
  	int dim, type = PyArray_CHAR;

	switch(spec->data_type) {
	case SHORT :
		type = PyArray_SHORT;
		break;
	case INT :
	case LONG :
		type = PyArray_LONG;
		break;
	case FLOAT :
		type = PyArray_FLOAT;
		break;
	case DOUBLE :
		type = PyArray_DOUBLE;
		break;
	}
	dim = spec->npts;
	result = (PyArrayObject *)PyArray_FromDimsAndData(1, &dim, type, (char *)spec->data.f_data);
	return PyArray_Return(result);
}

static PyObject *init_frame_array(IMAGE2D *frame) {

	PyArrayObject *result;
  	int dim[2], type = PyArray_CHAR;

	switch(frame->data_type) {
	case SHORT :
		type = PyArray_SHORT;
		break;
	case INT :
	case LONG :
		type = PyArray_LONG;
		break;
	case FLOAT :
		type = PyArray_FLOAT;
		break;
	case DOUBLE :
		type = PyArray_DOUBLE;
		break;
	}
	dim[0] = frame->ny;
	dim[1] = frame->nx;
	result = (PyArrayObject *)PyArray_FromDimsAndData(2, dim, type, (char *)frame->data.f_data);
	return PyArray_Return(result);
}

static PyObject *init_cube_array(IMAGE3D *cube) {

	PyArrayObject *result;
  	int dim[3], type = PyArray_CHAR;

	switch(cube->data_type) {
	case SHORT :
		type = PyArray_SHORT;
		break;
	case INT :
	case LONG :
		type = PyArray_LONG;
		break;
	case FLOAT :
		type = PyArray_FLOAT;
		break;
	case DOUBLE :
		type = PyArray_DOUBLE;
		break;
	}
	dim[0] = cube->nz;
	dim[1] = cube->ny;
	dim[2] = cube->nx;
	result = (PyArrayObject *)PyArray_FromDimsAndData(3, dim, type, (char *)cube->data.f_data);
	return PyArray_Return(result);
}

%}
